<template>
  <div ref="wrapper" class="absolute top-0 left-0 h-full w-full overflow-y-auto">
    <div :ref="`route-${key+1}`" v-for="(item, key) in items" :key="key">
      <SettingsSingle :index="key" @openInCanvas="manuallyOpenInCavas" />
    </div>
  </div>
</template>

<script>
import SettingsSingle from './editor-settings-single.vue'

export default {
  components: { SettingsSingle },
  data(){
    return {
      stopScroll: false
    }
  },
  computed: {
    items(){
      return this.$store.state.editor.items
    }
  },
  methods:{
    scrollToCurrent(){
      if(this.stopScroll) return
      const el = this.$refs[`route-${this.$route.params.item}`][0]
      const cont = this.$refs['wrapper']
      const scrollTo = el.getBoundingClientRect().top - cont.getBoundingClientRect().top + cont.scrollTop
      
      cont.scrollTo({
        top: scrollTo,
        left: 0,
        behavior: 'smooth'
      });
    },
    manuallyOpenInCavas(){
      this.stopScroll = true
      this.$api.once('router:afterEach', () => {
        setTimeout(() => this.stopScroll = false)
      })
    }
  },
  mounted(){
    this.$api.on('router:afterEach', this.scrollToCurrent)
  },
  beforeDestroy(){
    this.$api.off('router:afterEach', this.scrollToCurrent)
  }
}
</script>